/*
    Copyright 2008 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl-2.0.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

typedef unsigned char u8;



#define VER     "0.1"



u8 *faypwd(u8 *pwd);
int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, DWORD len);



struct {
    u8      *value;
    int     decode;
} getvalues[] = {
    { "POP3HostName", 0 },
    { "POP3UserName", 0 },
    { "POP3Password", 1 },
    { "SMTPserver",   0 },
    { "SMTPusername", 0 },
    { "SMTPPassword", 1 },
    { NULL,           0 }
};



int main(void) {
    int     i;
    u8      buff[4096];

    fputs("\n"
        "Desktop Fay passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    printf("- find the registry values to decode\n");
    for(i = 0; getvalues[i].value; i++) {
        if(regkeyr(HKEY_CURRENT_USER, "Software\\WinAppsPlanet\\Desktop Fay", getvalues[i].value, buff, sizeof(buff)) < 0) continue;
        printf("  %-14s %s\n", getvalues[i].value, getvalues[i].decode ? faypwd(buff) : buff);
    }

    printf("\n  press RETURN to exit\n");
    fgetc(stdin);
    return(0);
}



u8 *faypwd(u8 *pwd) {
    u8      a,
            i,
            s,
            x,
            len,
            *out;

    len = strlen(pwd) + 8;
    out = pwd;
    pwd -= 8;
    switch(pwd[8]) {
        case 'A': a = 0; break;
        case 'T': a = 1; break;
        case 'i': a = 2; break;
        case 'r': a = 3; break;
        case 'R': a = 4; break;
        case 'f': a = 5; break;
        case '7': a = 6; break;
        case 'e': a = 7; break;
        default:  a = 0; break;
    }
    s = a + 10;
    switch(pwd[s++ - 1]) {
        case 'h': a = 0; break;
        case 'L': a = 1; break;
        case 'S': a = 2; break;
        case 'o': a = 3; break;
        default:  a = 0; break;
    }
    x = pwd[s - 1] - a;
    for(i = 0; i < x; i++) {
        if(s > len) break;
        switch(pwd[s++ - 1]) {
            case 'A': a = 0; break;
            case 'T': a = 1; break;
            case 'i': a = 2; break;
            case 'r': a = 3; break;
            case 'R': a = 4; break;
            case 'f': a = 5; break;
            case '7': a = 6; break;
            case 'e': a = 7; break;
            default:  a = 0; break;
        }
        s += a;
        if(s > len) break;
        switch(pwd[s++ - 1]) {
            case 'h': a = 0; break;
            case 'L': a = 1; break;
            case 'S': a = 2; break;
            case 'o': a = 3; break;
            default:  a = 0; break;
        }
        out[i] = pwd[s++ - 1] - a;
    }
    out[i] = 0;
    return(out + 3);
}



int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, DWORD len) {
    HKEY    key;

    buff[0] = 0;
    if(RegOpenKeyEx(hKey, lpSubKey, 0, KEY_READ, &key) != ERROR_SUCCESS) {
        return(-1);
    }
    if(RegQueryValueEx(key, lpValueName, NULL, REG_NONE, buff, &len) != ERROR_SUCCESS) {
        RegCloseKey(key);
        return(-1);
    }
    RegCloseKey(key);
    buff[len] = 0;
    return(len);
}


